(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; }, __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
    for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
    function ctor() { this.constructor = child; }
    ctor.prototype = parent.prototype;
    child.prototype = new ctor;
    child.__super__ = parent.prototype;
    return child;
  };
  PuppetEnterpriseConsole.CloningController = (function() {
    __extends(CloningController, Batman.Controller);
    function CloningController() {
      this.activateFirstTab = __bind(this.activateFirstTab, this);
      this.cancelCloning = __bind(this.cancelCloning, this);
      this.navigateAway = __bind(this.navigateAway, this);
      this.updatePreview = __bind(this.updatePreview, this);
      CloningController.__super__.constructor.apply(this, arguments);
    }
    CloningController.prototype.tabs = ['errors', 'failures', 'overwrites', 'creations', 'successes'];
    CloningController.prototype.updatePreview = function() {
      this.set('cloningState', 'preview');
      this.set('loadingState', 'loading');
      this.set('nodeCount', null);
      this.set('activeTab', null);
      return this.load();
    };
    CloningController.prototype.moveContentTop = function(height) {
      return $('#content-wrapper').css({
        top: $(this).outerHeight(true)
      });
    };
    CloningController.prototype.setupClone = function(node, type, title, variation) {
      var alreadyCloning, obj, target, targetNode, transfer, wasHidden;
      this.unset('error');
      this.unset('cloningState');
      this.unset('loadingState');
      obj = {
        type: type,
        title: title
      };
      obj.parameters = variation.attributes;
      obj.nodes = variation.nodes;
      alreadyCloning = this.get('cloningResource');
      targetNode = $('#cloning-context');
      if (JSON.stringify(alreadyCloning) === JSON.stringify(obj)) {
        if (targetNode.is(':animated')) {
          return;
        }
        return targetNode.animate({
          top: -5
        }, {
          duration: 50
        }).animate({
          top: 0
        }, {
          duration: 400,
          easing: 'easeOutBounce'
        });
      } else {
        if (wasHidden = targetNode.is(":hidden")) {
          targetNode.css({
            display: 'block',
            overflow: 'hidden',
            height: 0
          });
        }
        transfer = $('<div class="ui-effects-transfer"></div>').appendTo(document.body).css({
          position: "absolute",
          padding: '0.5em',
          height: $(node).height(),
          width: $(node).width()
        });
        target = {
          top: [targetNode.offset().top, 'easeOutSine'],
          left: [targetNode.offset().left + (targetNode.width() - transfer.width()) / 2, 'easeOutSine'],
          opacity: 0,
          width: 0
        };
        if (targetNode.height()) {
          targetNode.parent().css({
            height: targetNode.height()
          });
        }
        transfer.css({
          zIndex: 1000000,
          backgroundColor: targetNode.css('backgroundColor'),
          top: $(node).offset().top,
          left: $(node).offset().left
        }).animate(target, {
          easing: 'easeInExpo',
          duration: 300,
          complete: __bind(function() {
            return targetNode.animate({
              height: 'show'
            }, {
              duration: 300,
              easing: 'easeOutBounce',
              step: wasHidden ? this.moveContentTop : void 0,
              complete: function() {
                targetNode.parent().css({
                  height: ''
                });
                return transfer.remove();
              }
            });
          }, this)
        });
        return targetNode.fadeOut(100, function() {
          targetNode.css({
            display: 'none',
            overflow: '',
            height: ''
          });
          return PuppetEnterpriseConsole.controllers.cloning.set('cloningResource', obj);
        });
      }
    };
    CloningController.prototype.preview = function() {
      if (!this.get('cloningResource')) {
        return this.redirect('/');
      }
      PuppetEnterpriseConsole.observe('currentRoute', this.navigateAway);
      return Node.observeAndFire('nodeSetID', this.updatePreview);
    };
    CloningController.prototype.navigateAway = function(currentRoute) {
      if ((currentRoute != null ? currentRoute.options.signature : void 0) !== "cloning#preview") {
        Node.forget('nodeSetID', this.updatePreview);
        this.unset('cloningState');
        this.unset('loadingState');
        PuppetEnterpriseConsole.forget('currentRoute', this.navigateAway);
        return PuppetEnterpriseConsole.forget('currentRoute', this.cancelCloning);
      }
    };
    CloningController.prototype.clone = function() {
      Node.forget('nodeSetID', this.updatePreview);
      PuppetEnterpriseConsole.forget('currentRoute', this.navigateAway);
      PuppetEnterpriseConsole.observe('currentRoute', this.cancelCloning);
      this.set('cloningState', 'cloning');
      this.set('loadingState', 'loading');
      this.set('nodeCount', Node.get('selected').length);
      Resource[this.get('cloningResource').type].invalidate();
      return this.load();
    };
    CloningController.prototype.cancelCloning = function() {
      return $('#cloning-context').animate({
        marginTop: 'hide',
        height: 'hide'
      }, {
        duration: 200,
        easing: 'easeOutBack',
        step: this.moveContentTop,
        complete: __bind(function() {
          this.navigateAway();
          $('#content-wrapper').css({
            top: ''
          });
          return this.unset('cloningResource');
        }, this)
      });
    };
    CloningController.prototype.activateFirstTab = function() {
      var key, result, _i, _len, _ref, _results;
      result = this.get('result');
      _ref = this.tabs;
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        key = _ref[_i];
        if (result['counts'][key]) {
          this.activateTab(null, key);
          break;
        }
      }
      return _results;
    };
    CloningController.prototype.activateTab = function(_, subject) {
      var result, view;
      result = this.get('result');
      this.set('activeTab', subject);
      view = new Batman.View({
        source: "cloning/preview/" + subject,
        contexts: [result, this]
      });
      return view.on('ready', function() {
        return Batman.DOM.replace('panel', view.get('node'));
      });
    };
    CloningController.prototype.load = function() {
      var res;
      this.openConnections || (this.openConnections = 0);
      this.openConnections++;
      res = this.get('cloningResource');
      this.unset('error');
      return $.ajax({
        url: this.get('cloningState') === 'preview' ? '/live-management/lm/clone/preview' : '/live-management/lm/clone',
        type: 'POST',
        data: {
          type: res.type,
          title: res.title,
          parameters: res.parameters,
          origin_nodes: res.nodes,
          nodeset_id: Node.get('nodeSetID')
        },
        success: __bind(function(data) {
          var x;
          data.sourceData = res;
          data.isEmpty = !((function() {
            var _i, _len, _ref, _ref2, _results;
            _ref = this.tabs;
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              x = _ref[_i];
              _results.push((_ref2 = data.counts[x]) != null ? _ref2 : 0);
            }
            return _results;
          }).call(this)).reduce(function(a, i) {
            return a + i;
          });
          this.set('result', data);
          return this.activateFirstTab();
        }, this),
        error: __bind(function(obj) {
          return this.set('error', ("<h3>" + (Batman.helpers.capitalize(this.get('cloningState'))) + " failed</h3>") + (obj.responseText != null ? "<div class=\"well\">" + obj.responseText + "</div>" : ''));
        }, this),
        complete: __bind(function() {
          return --this.openConnections || this.set('loadingState', 'loaded');
        }, this)
      });
    };
    return CloningController;
  })();
}).call(this);
